#ifndef FFT_h
#define FFT_h

#include "Arduino.h"
#include <arduinoFFT.h>

#define FPGA_DATA_CLK 22
#define FPGA_DATA_SYNC 24
#define FPGA_DATA_D0 26
#define FPGA_DATA_D1 28
#define FPGA_DATA_D2 30
#define FPGA_DATA_D3 32
#define FPGA_DATA_D4 34
#define FPGA_DATA_D5 36
#define FPGA_DATA_D6 38
#define FPGA_DATA_D7 40
#define MIN_FFT_THRESHOLD 10000

class FFT
{
  public:
    static void Init();
    static void fpgadata_clock();
    static void generate_fft();

  private:
    static uint32_t fpgadata_sync_counter;
    static byte fpgadata_stage;
    static uint32_t fpga_packet;
    static int32_t fpga_audio_stream;
    static arduinoFFT libFFT;
    static const uint16_t fft_samples = 512;
    static const uint16_t fpga_sample_rate = 12500;
    static double fpga_audio_buffer[fft_samples];
    static double vReal[fft_samples];
    static double vImag[fft_samples];
    static double maxfft_signal;

    static inline int digitalReadDirect(int pin);
    static inline void digitalWriteDirect(int pin, boolean val);
    static void PrintFFT(double *vData, uint16_t bufferSize);
};

#endif
