#ifndef LCD_h
#define LCD_h

#include <SPI.h>
#include "Adafruit_GFX.h"
#include <MCUFRIEND_kbv.h>
#include <TouchScreen.h>
#include "Arduino.h"
#include "lcd.h"

class LCD
{
  public:
    static void Init();
    static void displayFreqInfo();
    static void displayTopButtons(bool redraw);
    static void displayFFT(byte* data, int data_size);
    static void checkTouchPad();

  private:
    static String freq_string_hz;
    static String freq_string_khz;
    static String freq_string_mhz;
    static MCUFRIEND_kbv tft;
    static bool bandMenuOpened;
    
    static void resetTouchpadPins();
};

#endif
